const http = require('http')
const cheerio = require("cheerio")
const fs = require("fs")
const path = require("path")
const out = require("./out")

function Analyse(html) {
    let $ = cheerio.load(html)
    let result = []
    let list = $(".base-list>li")
    for (var index = 0; index < list.length; index++) {
        let element = $(list[index])
        let li = {
            prop: element.find(".prop").text().replace(/[\s.]/g, ""),
            desc: element.find("p").text().replace(/\s/g, "")
        }
        result.push(li)
    }
    return result
}

module.exports = function (word) {
    if (!/^[a-zA-Z.]+$/.test(word)) {
        return
    }
    console.log("use icba transform")
    return new Promise((resolve, rejeect) => {
        try {
            let data = fs.readFileSync(path.join(process.cwd(), "cache/" + word + ".json"))
            if (data) {
                out(word, JSON.parse(data), true)
            }
            resolve()
        } catch (error) {
            http.get(`http://www.iciba.com/${word}`, (response) => {
                let content = ""
                response.on("data", (data) => {
                    content += data
                })
                response.on("end", () => {
                    let result = Analyse(content)
                    out(word, result)
                    resolve()
                })
            }).on("error", (err) => {
                if (err.code === "ENOTFOUND") {
                    console.error(chalk.red("!!! network err"))
                } else {
                    console.error(err)
                }
            })
        }
    })
}
